/*****
 *
 * TBR11.PRG
 *
 * Luiz Quintela
 *
 * Based in a sample code from Fred Ho
 *
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr11 /N /W /A /B
 * RTLINK FILE tbr10 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test
// Important! 
// Go to start condition
LOCATE FOR test->fld5 >= 5

SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,RB+/W,,,BG/N")
@  2, 6 TO 22,72
@  2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "Bg/B,RB+/W,W/N,N,GR+/W,G+/B,R+/B,GR+/B"
b:colSep  := "  "
b:headSep := ""

// Custom Skippers
b:skipBlock     := {|nRecs| Skipper( nRecs )}
b:goTopBlock    := {|| GoTopDb()}
b:goBottomBlock := {|| GoBottomDb()}

// TBColumn objects
column := TBColumnNew( "Record #", {|| RECNO()})
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
b:addColumn( column )

WHILE .T.
   WHILE ( !b:stabilize() )
      nKey := INKEY()
      IF ( nKey != 0 )
         EXIT
         
      ENDIF

   END

   IF ( b:stable )
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ENDIF

END
RETURN NIL

/*****
 *
 * Skip to top of condition
 *
 */

STATIC FUNCTION GoTopDb()
WHILE (test->fld5 >= 5) .AND. (!BOF())
   SKIP -1
   IF !(test->fld5 >= 5)
      SKIP
      EXIT

   ENDIF

END
RETURN NIL

/*****
 *
 * Skip to the bottom of 
 * condition block
 *
 */

STATIC FUNCTION GoBottomDb()
WHILE (test->fld5 >= 5) .AND. (!EOF())
   SKIP

END
// Go back to the last occurrence
SKIP -1
RETURN NIL

/*****
 *
 * Main Skippper
 *
 */

STATIC FUNCTION Skipper( nRequest )
// nRequest is the number of records to be skipped
LOCAL nActually := 0

IF (nRequest == 0)
   SKIP 0

ELSEIF (nRequest > 0) .AND. (!EOF())
   // Keep skipping until number of skips
   // requested is satisfied
   WHILE (nActually < nRequest)
      SKIP
      // Evaluate condition for each record
      IF !(test->fld5 >= 5) .OR. EOF()
         SKIP -1
         EXIT

      ENDIF
      
      // Skip counter 
      nActually++

   END

ELSEIF (nRequest < 0)
   WHILE (nActually > nRequest)
      SKIP -1
      // This is check is important!
      // BOF bangs do not sit on phanton record
      // Rather, the top record is evaluated, 
      // and may meet the condition
      IF BOF()
         EXIT

      ENDIF
      // Evaluate condition for each record
      IF !(test->fld5 >= 5)
         SKIP
         EXIT

      ENDIF

      // Skip counter
      nActually--

   END

ENDIF
// Returns number of records actually skipped
RETURN nActually

// EOF - TBR11.PRG //
