/*****
 *
 * TBR12A.PRG
 *
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr12a /N /W /A /B
 * RTLINK FILE tbr12a PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, c, w

SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN

// Opening first file
USE test INDEX test NEW
// Opening second file
// For the example use the same 
// test file with another name
USE test1 NEW

// First file
SELECT test

SETCOLOR("BG/B,GR+/W,,,BG/N")
@  2, 6 CLEAR TO 10,72
@  2, 6 TO 10,72 DOUBLE
b := TBrowseDB( 3, 7, 9, 71 )
b:colSep  := "  "
b:headSep := ""
b:footSep := ""

SETCOLOR("N/BG,W+/RB,,,N/BG")
@ 12, 6 CLEAR TO 22,72
@ 12, 6 TO 22,72 DOUBLE
c := TBrowseDB( 13, 7, 21, 71 )
c:colSep  := "  "
c:headSep := ""
c:footSep := ""

// TBColumn objects
// First file
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "Browse #1"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )

// TBColumn Objects
// Second File
column := TBColumnNew( "Field 5", {|| test1->fld5} )
column:footing := "Browse #2"
c:addColumn( column )
column := TBColumnNew( "Field 6", {|| test1->fld6} )
c:addColumn( column )
column := TBColumnNew( "Field 7", {|| test1->fld7} )
c:addColumn( column )

// Remember: The variable contains a REFERENCE
// to the object

// First stabilize the unselected
// object
WHILE ( !c:stabilize() )
END
// Dehilite cell in the unselected object
c:deHilite()

// Current object
w := b

WHILE .T.
   WHILE ((!w:stabilize()) .AND. ((nKey := INKEY()) == 0))
   END

   IF ( w:stable )
      IF ( w:hitTop .OR. w:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF !MoveIt( nKey, w )
      IF ( nKey == K_ESC )
         CLS
         SETCURSOR(SC_NORMAL)
         RETURN NIL

      ELSEIF ( nKey == K_F10 )
         // Change Current Browse
         // First dehilite cell
         w:deHilite()

         // Change the Current Browse
         IF w == b
            w := c
            SELECT test1

         ELSE
            w := b
            SELECT test

         ENDIF

         // Hilite the Cell
         w:hilite()
      
      ENDIF
   
   ENDIF

END
RETURN NIL

/*****
 *
 * Cursor Movement Methods
 *
 */

FUNCTION MoveIt( nKey, oObj )
LOCAL nFound
LOCAL aKeys := ;
      { K_DOWN      ,;
        K_UP        ,;
        K_PGDN      ,;
        K_PGUP      ,;
        K_CTRL_PGUP ,;
        K_CTRL_PGDN ,;
        K_RIGHT     ,;
        K_LEFT      ,;
        K_HOME      ,;
        K_END       ,;
        K_CTRL_LEFT ,;
        K_CTRL_RIGHT,;
        K_CTRL_HOME ,;
        K_CTRL_END    }

LOCAL aMethods := { {|b| b:down()},;
                  {|b| b:up()},;
                  {|b| b:pageDown()},;
                  {|b| b:pageUp()},;
                  {|b| b:goTop()},;
                  {|b| b:goBottom()},;
                  {|b| b:right()},;
                  {|b| b:left()},;
                  {|b| b:home()},;
                  {|b| b:end()},;
                  {|b| b:panLeft()},;
                  {|b| b:panRight()},;
                  {|b| b:panHome()},;
                  {|b| b:panEnd()} }
             
// Search into array
nFound := ASCAN( aKeys, nKey )
IF nFound != 0
   EVAL( aMethods[nFound], oObj )

ENDIF
RETURN nFound != 0

// EOF - TBR12A.PRG //

