/*****
 *
 * TBR12B.PRG
 *
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr12b /N /W /A
 * RTLINK FILE tbr12b PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, c, w

SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
@ 24, 0 SAY SPACE(80) COLOUR "W+/RB"
@ 24, 0 SAY "   F10 - Shift between Browses" +;
            SPACE(10) +;
            "F9 - Move columns" +;
            SPACE(10) +;
            "ESC - Quit" COLOUR "W+/RB"

// Opening first file
USE test INDEX test NEW

// Create first Tbrowse object
SETCOLOR("BG/B,GR+/W,,,BG/N")
@  2, 6 CLEAR TO 10,72
@  2, 6 TO 10,72 DOUBLE
b := TBrowseDB( 3, 7, 9, 71 )
b:colorSpec := "BG/B,GR+/W,,,BG/N"
b:colSep    := "  "
b:headSep   := ""
b:footSep   := ""

SETCOLOR("N/BG,W+/RB,,,N/BG")
@ 12, 6 CLEAR TO 22,72
@ 12, 6 TO 22,72 DOUBLE
c := TBrowseDB( 13, 7, 21, 71 )
c:colorSpec := "N/BG,W+/RB,,,N/BG"
c:colSep    := "  "
c:headSep   := ""
c:footSep   := ""

// TBColumn objects
// First Browse
//
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "Browse #1"
b:addColumn( column )

column := TBColumnNew( "Field 2", {|| test->fld2} )
column:footing := "Browse #1"
b:addColumn( column )

column := TBColumnNew( "Field 3", {|| test->fld3} )
column:footing := "Browse #1"
b:addColumn( column )

column := TBColumnNew( "Field 4", {|| test->fld4} )
column:footing := "Browse #1"
b:addColumn( column )

// Second Browse
//
column := TBColumnNew( "Field 5", {|| test->fld5} )
column:footing := "Browse #2"
c:addColumn( column )

column := TBColumnNew( "Field 6", {|| test->fld6} )
column:footing := "Browse #2"
c:addColumn( column )

column := TBColumnNew( "Field 7", {|| test->fld7} )
column:footing := "Browse #2"
c:addColumn( column )

// First stabilize second object
WHILE !c:stabilize()
END
// Dehilite cell in the unselected object
c:deHilite()
// Current object will be the first one
w := b

WHILE .T.
   // Stabilize current object
   WHILE (!w:stabilize()) .AND. ((nKey := INKEY()) == 0)
   END

   IF ( w:stable )
      IF ( w:hitTop .OR. w:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF !TBMoveCursor( nKey, w )
      IF ( nKey == K_ESC )
         CLS
         SETCURSOR(SC_NORMAL)
         EXIT

      ELSEIF ( nKey == K_F9 )
         // Current column will be transfered
         // from one browse to another but, only if you
         // have more than one column in the current
         // selected one
         IF w:colCount > 1
            // Take the column out
            column := w:delColumn(w:colPos)
            IF w == b
               // insert column at current position
               c:insColumn(c:colPos, column)
               // Stabilize
               WHILE !c:stabilize(); END
               c:deHilite()

            ENDIF
            IF w == c
               b:insColumn(b:colPos, column)
               WHILE !b:stabilize(); END
               b:deHilite()

            ENDIF
            // To be in the safe side
            WHILE !w:stabilize(); END
         ELSE
            ALERT("You have to have more than one column;"+;
                  "in the current browse in order to;"+;
                  "move columns away",;
                  {"Continue"})

         ENDIF

      ELSEIF ( nKey == K_F10 )
         // Change Current Browse
         // First dehilite cell
         w:deHilite()

         // Change the Current Browse
         IF(w == b, w := c, w := b)

         // Hilite the Cell
         w:hilite()
      
      ENDIF
   
   ENDIF

END
RETURN NIL

FUNCTION TBMoveCursor( nKey, oObj )
LOCAL nFound
LOCAL aCursorMethods := ;
      { K_DOWN      , {|b| b:down()},;
        K_UP        , {|b| b:up()},;
        K_PGDN      , {|b| b:pageDown()},;
        K_PGUP      , {|b| b:pageUp()},;
        K_CTRL_PGUP , {|b| b:goTop()},;
        K_CTRL_PGDN , {|b| b:goBottom()},;
        K_RIGHT     , {|b| b:right()},;
        K_LEFT      , {|b| b:left()},;
        K_HOME      , {|b| b:home()},;
        K_END       , {|b| b:end()},;
        K_CTRL_LEFT , {|b| b:panLeft()},;
        K_CTRL_RIGHT, {|b| b:panRight()},;
        K_CTRL_HOME , {|b| b:panHome()},;
        K_CTRL_END  , {|b| b:panEnd()} }

// Search into array
nFound := ASCAN( aCursorMethods, nKey )
IF nFound != 0
   EVAL( aCursorMethods[++nFound], oObj )

ENDIF
RETURN nFound != 0

// EOF - TBR12B.PRG //
