/*****
 *
 * TBR12C.PRG
 *
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr12c /N /W /A /B
 * RTLINK FILE tbr12c PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

#define   TRUE   .T.

FUNCTION Main()
LOCAL b, column, nKey, c, w
FIELD purdate, invno IN file1
FIELD invnumber, item, itemdesc IN file2

SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("W+/RB")
@ 24, 0
@ 24, 0 SAY "ESC - Quit      F10 - Shift Browses"

// Open first file
USE file1 INDEX file1 NEW

// Open second file
USE file2 INDEX file2 NEW

// First file
SELECT file1

// First Browse
SETCOLOR("BG/B,GR+/W,,,BG/N")
@  2, 6 CLEAR TO 10,32
@  2, 6 TO 10,32 DOUBLE
b := TBrowseDB( 3, 7, 9, 31 )
b:colSep  := "  "
b:headSep := ""
b:footSep := ""
b:cargo := 0

// Second Browse
SETCOLOR("N/BG,W+/RB,,,N/BG")
@ 12, 6 CLEAR TO 22,72
@ 12, 6 TO 22,72 DOUBLE
c := TBrowseDB( 13, 7, 21, 71 )
c:skipBlock     := {|nSkip| SkipDB(nSkip,;
                   {|| file1->invno == file2->invnumber})}
c:goTopBlock    := {|| GoTopDB(;
                   {|| file1->invno == file2->invnumber})}
c:goBottomBlock := {|| GoBottomDB(;
                   {|| file1->invno == file2->invnumber})}
c:colSep  := "  "
c:headSep := ""
c:footSep := ""


// TBColumn objects
// First file
column := TBColumnNew( "Purchase Date", {|| purdate} )
column:footing := "Parent"
b:addColumn( column )
column := TBColumnNew( "Invoice#", {|| invno} )
b:addColumn( column )

// TBColumn Objects
// Second File
column := TBColumnNew( "Invoice#", {|| invnumber} )
column:footing := "Child"
c:addColumn( column )
column := TBColumnNew( "Item", {|| item} )
c:addColumn( column )
column := TBColumnNew( "Description", {|| itemdesc} )
c:addColumn( column )

// Remember: The variable contains a REFERENCE
// to the object

// Dehilite cell in the unselected object
c:deHilite()

// Current object
w := b

WHILE TRUE
   WHILE ((!w:stabilize()) .AND. (NEXTKEY() == 0))
   END

   IF (NEXTKEY() == 0) .AND. (b:cargo != file1->(RECNO()))
      b:cargo := file1->(RECNO())
      SELECT file2
      SEEK file1->invno
      c:refreshAll()
      WHILE (!c:stabilize())
      END
      c:deHilite()
      SELECT file1

   ENDIF

   IF ( w:stable )
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF !MoveIt( nKey, w )
      IF ( nKey == K_ESC )
         CLS
         SETCURSOR(SC_NORMAL)
         RETURN NIL

      ELSEIF ( nKey == K_F10 )
         // Change Current Browse
         // First dehilite cell
         w:deHilite()

         // Change the Current Browse
         IF w == c
            w := b
            SELECT file1

         ELSE
            w := c
            SELECT file2

         ENDIF

         // Hilite the Cell
         w:hilite()
      
      ENDIF
   
   ENDIF

END

/*****
 *
 * Cursor Movement Methods
 *
 */

FUNCTION MoveIt( nKey, oObj )
LOCAL nFound
LOCAL aCursorMethods := ;
      { K_DOWN      , {|b| b:down()},;
        K_UP        , {|b| b:up()},;
        K_PGDN      , {|b| b:pageDown()},;
        K_PGUP      , {|b| b:pageUp()},;
        K_CTRL_PGUP , {|b| b:goTop()},;
        K_CTRL_PGDN , {|b| b:goBottom()},;
        K_RIGHT     , {|b| b:right()},;
        K_LEFT      , {|b| b:left()},;
        K_HOME      , {|b| b:home()},;
        K_END       , {|b| b:end()},;
        K_CTRL_LEFT , {|b| b:panLeft()},;
        K_CTRL_RIGHT, {|b| b:panRight()},;
        K_CTRL_HOME , {|b| b:panHome()},;
        K_CTRL_END  , {|b| b:panEnd()} }

// Search into array
nFound := ASCAN( aCursorMethods, nKey )
IF nFound != 0
   EVAL( aCursorMethods[++nFound], oObj )

ENDIF
RETURN nFound != 0

STATIC FUNCTION GoTopDB( bWhileCond )
WHILE EVAL( bWhileCond ) .AND. !BOF()
   SKIP -1
   IF !EVAL( bWhileCond )
      SKIP
      EXIT

   ENDIF

END
RETURN NIL

STATIC FUNCTION GoBottomDB( bWhileCond )
WHILE EVAL( bWhileCond ) .AND. !EOF()
   SKIP

END
SKIP -1
RETURN NIL

STATIC FUNCTION SkipDB( nSkipRequest, bWhileCOnd )
LOCAL nActSkip := 0

IF nSkipRequest == 0
   SKIP 0

ELSEIF nSkipRequest > 0 .AND. !EOF()
   WHILE nActSkip < nSkipRequest
      SKIP

      IF !EVAL( bWhileCond ) .OR. EOF()
        SKIP -1
        EXIT

      END
      nActSkip++

   END

ELSEIF nSkipRequest < 0
   WHILE nActSkip > nSkipRequest
      SKIP -1
      IF BOF()
         EXIT

      ENDIF

      IF !EVAL( bWhileCond )
         SKIP
         EXIT

      ENDIF
      nActSkip--

   END

ENDIF
RETURN (nActSkip)

// EOF - TBR12C.PRG //

