/*****
 *
 * TBR12E.PRG
 * Luiz Quintela
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 * Clipper tbr12e /N /W /A /B
 * RTLINK FILE tbr12e PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

#define   TRUE         .T.

// Shift Cursor Keys
#define   K_SH_UP      56
#define   K_SH_DOWN    50
#define   K_SH_LEFT    52
#define   K_SH_RIGHT   54

FUNCTION Main()
LOCAL b, column, nKey
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

SETMODE(50,80)

USE test INDEX test NEW
SETCURSOR(SC_NONE)

SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR( "BG/B,RB+/W,,,BG/N" )
@ 2, 6 CLEAR TO 13,55
@ 2, 6 TO 13,55 DOUBLE

b:= TBrowseDB( 3, 7, 12, 54 )
b:colSep  := "  "
b:headSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
b:addColumn( column )
b:freeze := 1

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := INKEY()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)

   ENDIF

   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETMODE(25,80)
      SETCURSOR(SC_NORMAL)
      EXIT

   ELSEIF ( nKey == K_ALT_S )
      SizeIt( b )

   ELSEIF ( nKey == K_ALT_M )
      MoveIt( b )

   ENDIF

END
RETURN NIL

FUNCTION MoveIt( obj )
// Remember: Objects are passed by REFERENCE
//
LOCAL cScreen, cColours
LOCAL nKey, t, l, b, r

t := obj:nTop - 1
l := obj:nLeft - 1
b := obj:nBottom + 1
r := obj:nRight + 1

// Screen
cColours := SETCOLOR("W+/N")
cScreen  := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )
@ t, l, b, r BOX CHR(219)

WHILE TRUE
   nKey := INKEY(0)
   RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cScreen )

   IF ( nKey == K_UP )
      IF t != 0
         --t
         --b

      ENDIF
         
   ELSEIF ( nKey == K_DOWN )
      IF b != MAXROW()
         ++b
         ++t

      ENDIF

   ELSEIF ( nKey == K_LEFT )
      IF l != 0
         --l
         --r

      ENDIF

   ELSEIF ( nKey == K_RIGHT )
      IF r != MAXCOL()
         ++r
         ++l

      ENDIF

   ELSEIF ( nKey == K_ENTER )
      EXIT

   ENDIF
   @ t, l, b, r BOX CHR(219)

END
SETCOLOR("N/W")
CLS
SETCOLOR(cColours)
@ t, l TO b,r DOUBLE

// Objects are passed by REFERENCE
// When you modify the instance variables
// nTop, nLeft, nBottom, nRight
// you are modifying at the b object above
// because obj has a reference to b
//
obj:nTop    := ++t
obj:nLeft   := ++l
obj:nBottom := --b
obj:nRight  := --r
RETURN NIL

FUNCTION SizeIt( obj )
LOCAL cScreen, cColours
LOCAL nKey, t, l, b, r

t := obj:nTop - 1
l := obj:nLeft - 1
b := obj:nBottom + 1
r := obj:nRight + 1

cColours := SETCOLOR("W+/N")
cScreen  := SAVESCREEN( 0, 0, MAXROW(), MAXCOL() )
@ t, l, b, r BOX CHR(219)

WHILE TRUE
   nKey := INKEY(0)
   RESTSCREEN( 0, 0, MAXROW(), MAXCOL(), cScreen )

   IF ( nKey == K_UP )
      t := IF( t != 0, --t, t )
         
   ELSEIF ( nKey == K_DOWN )
      b := IF( b != MAXROW(), ++b, b )

   ELSEIF ( nKey == K_LEFT )
      l := IF( l != 0, --l, l )

   ELSEIF ( nKey == K_RIGHT )
      r := IF( r != MAXCOL(), ++r, r )

   ELSEIF ( nKey == K_SH_UP )
      b := IF( b != (t + 2), --b, b )
         
   ELSEIF ( nKey == K_SH_DOWN )
      t := IF( t != (b - 2), ++t, t )

   ELSEIF ( nKey == K_SH_LEFT )
      r := IF( r != (l + 35), --r, r )

   ELSEIF ( nKey == K_SH_RIGHT )
      l := IF( l != (r - 35), ++l, l )

   ELSEIF ( nKey == K_ENTER )
      EXIT

   ENDIF
   @ t, l, b, r BOX CHR(219)

END
SETCOLOR("N/W")
CLS
SETCOLOR(cColours)
@ t, l TO b,r DOUBLE

obj:nTop    := ++t
obj:nLeft   := ++l
obj:nBottom := --b
obj:nRight  := --r
//
// In this case you do not need to issue a
// configure() because this is automatic when you
// change the instance variables nTop, nLeft,
// nBottom, nRight
RETURN NIL

// EOF - TBR12E.PRG //
