/*****
 *
 * TBR3.PRG
 *
 * Luiz Quintela
 *
 * Copyright (c) 1990 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr3 /N/W/A
 * RTLINK FILE tbr3 PLL base50
 *
 */

// Include Header Files
#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW

// Cursors are for GETs, so turn it off
// The SC_XXXX contants are defined in setcurs.ch
//
SETCURSOR(SC_NONE)

SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR( "BG/B,RB+/W,,,BG/N" )
@ 2, 6 CLEAR TO 22,72
@ 2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )

b:colSep  := "  "
b:headSep := ""
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
// Footer for this column
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
// Footer for this column
column:footing := "Last"
b:addColumn( column )

// One useful thing: freeze one or more columns on the screen
// You could accomplish this using the instance variable 
// freeze. It defines the number of data columns frozen
// on the left side of the display

b:freeze := 1

// If later you need to unlock the column, just 
// use b:freeze := 0

WHILE .T.
   // Do not allow cursor to move into frozen columns
   // (This is Optional!)
   // You will use the instance variable colPos to get
   // current cursor column position
   IF  ( b:colPos <= b:freeze )
       // As you can see b:colPos is assignable
       b:colPos := b:freeze + 1

   ENDIF

   // Stabilization
   WHILE ( !b:stabilize() )
      nKey := InKey()
      IF ( nKey != 0 )
         EXIT // abort if a key is waiting

      ENDIF

   END

   IF ( b:stable )
      // Is always a good idea tell the user about
      // end or beginning of file
      // b:hitTop contais a .T. if an attempt was made 
      // to navigate beyond the beginning of data source
      // b:hitBottom contais a .T. if an attempt was made 
      // to navigate beyond the end of data source

      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ENDIF

END
RETURN NIL

// EOF - TBR3.PRG //

