/*****
 *
 * TBR4.PRG
 *
 * Luiz Quintela
 *
 * Copyright (c) 1990 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr4 /N /W /A /B
 * RTLINK FILE tbr4 PLL base50
 *
 */

// Include Header Files
#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, aColors
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW
SETCURSOR(SC_NONE)

SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR( "BG/B,RB+/W,,,BG/N" )
@ 2, 6 CLEAR TO 22,72
@ 2, 6 TO 22,72 DOUBLE

b:= TBrowseDB( 3, 7, 21, 71 )

// Now, we will use some colours for this column
// Use the instance variable colorSpec, which contains a
// character string defining a colour table to the browse
// display.
// As a default, the current SETCOLOR() is copied into this 
// variable

// As a matter of fact some of my colour preferrences
// are a disaster
b:colorSpec := "BG/B,RB+/W,W/N,N,GR+/W,G+/B,R+/B,GR+/B"

b:colSep  := "  "
b:headSep := ""
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )

// defColor contains an array of numeric indexes into the colour
// table. The first determines the unselected color which
// determines the colour used to headings, footings, etc.
// It is also used to display values when the cursor is not
// on the data value being displayed.
// The second value determines the selected colour which is used
// to display the current browse cell
// Note that colorus set using TBColumn:colorBlock overrides
// those set by TBColumn:defColor

column := TBColumnNew( "Field 5", {|| test->fld5} )

// Or you can use colorBlock
// This instance variable contains an optional code block that 
// determines the colour of data items as they are displayed.
// This block is evaluated each time a new value
// is retrieved using TBColumn:block
// The retrieved data value is passed as an argument to 
// TBColumn:colorBlock, which must return an array containing
// two numeric values

column:colorBlock := { |y| ;
     IF(y <= 3, { 6, 2 }, IF(y >= 5, { 7, 2 }, { 8, 2 } )) }

column:footing := "Last"
b:addColumn( column )
b:freeze := 1

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := INKEY()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      WHILE( (nKey := INKEY(.5) ) == 0 )
         @  0, 70 SAY " " + TIME() + " "

      END

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ENDIF

END
RETURN NIL

// EOF - TBR4.PRG //

