/*****
 *
 * TBR5.PRG
 *
 * Luiz Quintela
 *
 * Copyright (c) 1990 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr5 /N /W /A /B
 * RTLINK FILE tbr5 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, aColors, bData
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,GR+/B,,,BG/N")
@  2, 6 CLEAR TO 22,72
@  2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "BG/B,RB+/W,W/N,N,GR+/W,W+/B,R+/B,GR+/B"

b:colSep  := "  "
b:headSep := ""
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )

// cargo
// is an instance variable of ANY DATA TYPE, allowing
// arbitrary information to be attached to a TBColumn object and
// retrieved later

column:cargo   := {|| Recolor(column) }

column:footing := "Last"
bData := column
b:addColumn( column )
b:freeze := 1

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := INKEY()
      IF ( nKey != 0 )

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ELSEIF ( nKey == K_F10 )
      // Check to see if you are at the right place
      IF ( b:colPos == 5 )
         // If so, go ahead
         // First evaluate bdata:cargo
         // Check this evaluation at the UDF Recolor()

         // Now, you will replace the old column object
         // with the new one
         // setColumn( colPos, newObjColumn ) => currentObjColumn
         // setColumn replaces the TBColumn object 
         // The value returned is the current column object
         b:setColumn( b:colPos, EVAL( bData:cargo ) )

         b:configure()
         // Causes the TBrowse object to 
         // re-examine all instance variables and TBColumn 
         // objects, and them reconfigure its internal settings
         // as required

         b:refreshAll()
         // Internally marks all data rows as
         // invalid, causing them to be refilled and redisplayed
         // during the NEXT stabilize loop

      ENDIF

   ENDIF

END
RETURN NIL

STATIC FUNCTION Recolor( bBlock )
// You receive the column object in bBlock
LOCAL GetList := {}  // For the Get System
LOCAL cScr  := SAVESCREEN( 6, 20, 17, 39 )
LOCAL cClr  := SETCOLOR( "GR+/W,B+/W" )
LOCAL nCurs := SETCURSOR(SC_NORMAL)
LOCAL nMenu := 3, nNum := 0.00

// This is not a beautiful screen but it woks!
@  6,20 CLEAR TO 17,39
@  6,20 TO 17,39 DOUBLE
@  7,22 SAY "Select"
@  9,22 PROMPT "Less Than"
@ 11,22 PROMPT "Greater Than"
@ 13,22 PROMPT "Equal to"
MENU TO nMenu

@ 16,22 SAY "Value:" GET nNum PICTURE "9.99"
READ

// Here you decide what colour you will use in your column
IF nMenu == 1
   bBlock:colorBlock := { |y| IF(y < nNum, { 7, 2 },;
	                       { 1, 2 }) }
ELSEIF nMenu == 2
   bBlock:colorBlock := { |y| IF(y > nNum, { 6, 2 },;
	                       { 1, 2 }) }
ELSE
   bBlock:colorBlock := { |y| IF(y == nNum, { 8, 2 },;
	                       { 1, 2 }) }

ENDIF
SETCURSOR(nCurs)
SETCOLOR(cClr)
RESTSCREEN( 6, 11, 17, 30, cScr )

// And return the altered column object
RETURN bBlock

// EOF - TBR5.PRG //
