/*****
 *
 * TBR6.PRG
 *
 * Luiz Quintela 
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr6 /N /W /A /B
 * RTLINK FILE tbr6 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, aColors, bData
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW
SETCURSOR(SC_NONE)

SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,GR+/B,,,BG/N")
@  2, 6 CLEAR TO 22,72
@  2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "BG/B,RB+/W,W/N,N,GR+/W,W+/B,R+/B,GR+/B"
b:colSep  := "  "
b:headSep := ""
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
column:footing := "Last"
b:addColumn( column )
b:freeze := 1

// cargo
// This is the same principle used in TBColumn:cargo
// But now we will use TBrowse:cargo
b:cargo := {|| ChangeIt() }

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := InKey()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ELSEIF ( nKey == K_F10 )
      b:setColumn( 5, EVAL( b:cargo ) )

      // You do not need to issue a configure()
      // because setColumn() causes a new configuration
      // automatically

      b:refreshAll()
      // Internally marks all data rows as
      // invalid, causing them to be refilled and redisplayed
      // during the NEXT stabilize loop

   ENDIF

END
RETURN NIL

STATIC FUNCTION ChangeIt()
LOCAL  column
STATIC IsFld5 := .T.
IF IsFld5
   IsFld5 := .F.
   column := TBColumnNew( "Field 7", {|| test->fld7} )
   column:footing := "Last"

ELSE
   IsFld5 := .T.
   column := TBColumnNew( "Field 5", {|| test->fld5} )
   column:footing := "Last"

ENDIF
RETURN column

// EOF - TBR6.PRG //
