/*****
 *
 * TBR6A.PRG
 *
 * Luiz Quintela 
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr6a /N /W /A /B
 * RTLINK FILE tbr6a PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

#define   TRUE     .T.
#define   FALSE    .F.

FUNCTION Main()
LOCAL b, column, nKey, aColors, bData
LOCAL lLogic := FALSE
LOCAL col
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,GR+/B,,,BG/N")
@  2, 6 CLEAR TO 22,72
@  2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "BG/B,RB+/W,W/N,N,GR+/W,W+/B,R+/B,GR+/B"
b:headSep := ""
b:colSep  := "  "
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 7", {|| test->fld7} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
column:footing := "Last"
b:addColumn( column )
b:freeze := 1

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := InKey()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ELSEIF ( nKey == K_F10 )
      IF lLogic
         lLogic := FALSE
         // insColumn is a method which allows a column
         // object to be inserted into the middle of a 
         // browse. The return value is a reference to
         // the column object being inserted
         b:insColumn( b:colPos, col )

      ELSE
         lLogic := TRUE
         // delColumn is a method which allows a column
         // object to be deleted from a browse. The return 
         // value is a reference to the column object being 
         // deleted
         col := b:delColumn( b:colPos )

      ENDIF

      b:refreshAll()

   ENDIF

END
RETURN NIL

// EOF - TBR6A.PRG //
