/*****
 *
 * TBR7.PRG
 *
 * Luiz Quintela
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr7 /N /W /A /B
 * RTLINK FILE tbr7 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

FUNCTION Main()
LOCAL b, column, nKey, aColors, nCnt, aLowHi
SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON

USE test INDEX test NEW
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,GR+/B,,,BG/N")
@  2, 6 CLEAR TO 22,72
@  2, 6 TO 22,72 DOUBLE

b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "BG/B,RB+/W,W/N,N,GR+/W,W+/B,R+/B,GR+/B"
b:colSep  := "  "
b:headSep := ""
b:footSep := ""

// TBColumn objects
column := TBColumnNew( "Field 1", {|| test->fld1} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", {|| test->fld2} )
b:addColumn( column )
column := TBColumnNew( "Field 3", {|| test->fld3} )
b:addColumn( column )
column := TBColumnNew( "Field 4", {|| test->fld4} )
b:addColumn( column )
column := TBColumnNew( "Field 5", {|| test->fld5} )
column:footing := "Last"
b:addColumn( column )
b:freeze := 1
b:cargo := {|| ChgClr() }

WHILE .T.
   IF  ( b:colPos <= 1 )
       b:colPos := b:freeze + 1

   ENDIF

   WHILE ( !b:stabilize() )
      nKey := InKey()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   // Process key
   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      RETURN NIL

   ELSEIF ( nKey == K_F10 )
      // Evaluate attached cargo
      aLowHi := EVAL( b:cargo )

      // Change all colours
      // Transverse all columns
      // Starting at column 1 up to colCount which contains
      // the total number of data columns in the browse
      FOR nCnt := 1 TO b:colCount
          // getColumn is a method which returns a TBColumn
          // object
          column := b:getColumn( nCnt )
          column:defColor   := { 1, 2 }
          column:colorBlock := { || LineClr( aLowHi ) }
          column:defColor   := { 1, 2 }
          b:setColumn( nCnt, column )

      NEXT

      b:configure()
      b:refreshAll()

   ENDIF
   
END
RETURN NIL

STATIC FUNCTION ChgClr()
LOCAL GetList := {}
LOCAL column, nLow := 1, nHi := 200
LOCAL cScr  := SAVESCREEN( 7, 10, 11, 27 )
LOCAL cClr  := SETCOLOR( "GR+/W,B+/W" )
LOCAL nCurs := SETCURSOR(SC_NORMAL)
// First, ask for data rows range
@  7,10 CLEAR TO 11,27
@  8,12 SAY "From line:" GET nLow PICTURE "999"
@ 10,12 SAY "To line:"   GET nHi  PICTURE "999"
READ
SETCURSOR(nCurs)
SETCOLOR(cClr)
RESTSCREEN( 7, 10, 11, 27, cScr )
RETURN IF(LASTKEY() == K_ESC, { 1, 200 }, { nLow, nHi } )


STATIC FUNCTION LineClr( aLowHi )
IF RECNO() >= aLowHi[1] .AND. RECNO() <= aLowHi[2]
   RETURN { 6 , 2 }
ELSE
   RETURN { 1, 2 }
ENDIF
// Dummy!
RETURN NIL

// EOF - TBR7.PRG //

