/*****
 *
 * TBR8C.PRG
 *
 * Luiz Quintela
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr8 /N /W /A /B
 * RTLINK FILE tbr8 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

#xtranslate     GETSETBLOCK      =>     (column:cargo)\[1\]
#xtranslate     BLOCKPICTURE     =>     (column:cargo)\[2\]

FUNCTION Main()
LOCAL b, column, nKey, aColors

SET SCOREBOARD OFF
SET DATE       BRITISH
SET CONFIRM    ON
READEXIT(.T.)

USE test INDEX test NEW
SETCURSOR(SC_NONE)
SETCOLOR("N/W")
CLEAR SCREEN
SETCOLOR("BG/B,GR+/B,,,BG/N")
@  2, 6 CLEAR TO 22,72
@  2, 6 TO 22,72
b := TBrowseDB( 3, 7, 21, 71 )
b:colorSpec := "BG/B,GR+/W,W/N,N,GR+/W,N/B,R+/B,GR+/B,W+/BG"
b:headSep   := ""
b:colSep    := "  "
b:footSep   := ""

// TBColumn objects
// Due to the fact that ahead in this example
// we will edit the field, we need to assign a get-set
// block to the object
//
// Use FIELDBLOCK("field")
// FIELDBLOCK() assumes you are using a field in the current
// work area
// If you need to use a field in another area use FIELDWBLOCK()
//
column := TBColumnNew( "Record#", {|| RECNO()} )
column:footing := "First"
b:addColumn( column )
column := TBColumnNew( "Field 2", FIELDBLOCK("fld2") )
column:cargo := { FIELDBLOCK("fld2"), "" }
column:width := 10
b:addColumn( column )
column := TBColumnNew( "Field 3", FIELDBLOCK("fld3") )
column:cargo := { FIELDBLOCK("fld3"), "" }
column:width := 30
b:addColumn( column )
column := TBColumnNew( "Field 4", FIELDBLOCK("fld4") )
column:cargo := { FIELDBLOCK("fld4"), "" }
column:width := 5
b:addColumn( column )
column := TBColumnNew( "Field 5", ;
                       {|| TRANSFORM(test->fld5, "99,999.99")})
column:cargo   := { FIELDBLOCK("fld5"), "99,999.99" }
column:footing := "Last"
column:width   := 10
b:addColumn( column )

b:freeze := 1

WHILE .T.
   IF  ( b:colPos <= b:freeze )
       b:colPos := b:freeze + 1

   ENDIF

   // Regular colour
   b:colorRect({b:rowPos, b:freeze + 1, b:rowPos, b:colCount},;
               {1, 1})
   WHILE !(b:stabilize())
      nKey := INKEY()
      IF ( nKey != 0 )
         EXIT

      ENDIF

   END

   IF ( b:stable )
      // Bar colour
      b:colorRect({b:rowPos, b:freeze + 1, b:rowPos,;
                   b:colCount}, {9, 2})
      // Since you are painting a group of cells in a
      // different colour, you should hilite the
      // current cell (specially if you are going to edit)
      b:hilite()
      IF ( b:hitTop .OR. b:hitBottom )
         TONE(87.3,1)
         TONE(40,3.5)

      ENDIF
      nKey := INKEY(0)         

   ENDIF

   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()

   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      CLS
      SETCURSOR(SC_NORMAL)
      EXIT

   ELSEIF ( nKey == K_ENTER )
      DoGet( b )

   ENDIF

END
RETURN NIL

STATIC FUNCTION DoGet( b )
LOCAL nCursSave
LOCAL column, get, nKey

nCursSave := SETCURSOR(SC_NORMAL)

// make sure browse is stable
WHILE !(b:stabilize())
END

// get column object from browse based on its position
column := b:getColumn( b:colPos )

// create a corresponding GET
get := GetNew(ROW(), COL(), GETSETBLOCK, ;
              column:heading, BLOCKPICTURE,;
              "BG/B,N/W,,,BG/B")

// read it
READMODAL( {get} )

// force redisplay of current row
b:refreshCurrent()

// check exit key
nKey := LASTKEY()
IF ( nKey == K_UP .OR. nKey == K_DOWN .OR. ;
     nKey == K_PGUP .OR. nKey == K_PGDN )
     KEYBOARD CHR( nKey )

ENDIF
SETCURSOR(SC_NONE)
RETURN NIL

// EOF - TBR8C.PRG //

