/*****
 *
 * TBR9.PRG
 *
 * Illustration of TBROWSE and GET objects
 * Copyright (c) 1991 Nantucket Corporation.
 *                    All Rights Reserved.
 *
 * Clipper tbr9 /N /A /W /B
 * RTLINK FILE tbr9 PLL base50
 *
 */

#include "inkey.ch"
#include "setcurs.ch"

#define    MY_HSEP     ""
#define    MY_CSEP     "  "
#define    FALSE      .F.
#define    TRUE       .T.

FUNCTION MAIN(datafile, indexfile)
IF VALTYPE(datafile) == "U"
   ?
   ? "Must enter name of data file on command line."
   ?
   QUIT

ENDIF

IF !(FILE(datafile) .OR. FILE(datafile + ".dbf"))
   ?
   ? "File not found."
   ?
   QUIT

ENDIF
SETCOLOR( "N/BG" )
CLS

// file exists
IF VALTYPE(indexfile) == "C" .and.;
   (FILE(indexfile) .OR. FILE(indexfile + IndexExt()))
   USE (datafile) INDEX (indexfile)

ELSE
   USE (datafile)

ENDIF

MyBrowse(3, 6, MAXROW() - 2, MAXCOL() - 6)
CLS
RETURN NIL

/*****
 *
 * MyBrowse()
 *
 */

FUNCTION MyBrowse(nTop, nLeft, nBottom, nRight)
LOCAL b, column, cType, n
LOCAL cColorSave, nCursSave
LOCAL nKey, lAppend

b := TBrowseDB(nTop, nLeft, nBottom, nRight)
b:headSep := MY_HSEP
b:colSep  := MY_CSEP

b:colorSpec := "N/W, N/BG, B/W, B/BG, B/W, B/BG, R/W, B/R"
// add a column for recno
column := TBColumnNew( "  Rec #", {|| RECNO()} )
b:addColumn(column)

// add a column for each field in the current workarea
FOR n := 1 to FCOUNT()
    // make the new column
    column := TBColumnNew( FIELDNAME(n), ;
              FIELDWBLOCK(FIELDNAME(n), SELECT()) )
    b:addColumn(column)

NEXT
b:freeze := 1

// make a window shadow
cColorSave := SETCOLOR("N/N")
@ nTop + 1, nLeft + 1 CLEAR TO;
  nBottom + 1, nRight + 1
SETCOLOR("W/W")
@ nTop, nLeft CLEAR TO nBottom, nRight
SETCOLOR(cColorSave)
nCursSave := SETCURSOR(SC_NONE)
lAppend   := FALSE

WHILE TRUE
   IF ( b:colPos <= b:freeze )
       b:colPos := b:freeze + 1
		
   ENDIF

   WHILE ( !b:stabilize() )
      nKey := INKEY()
      IF ( nKey != 0 )
	 EXIT

      ENDIF

   END
   IF ( b:stable )
      IF ( b:hitBottom .OR. b:hitBottom)
	  TONE(125, 0)
			
      ENDIF                          
      WHILE( (nKey := INKEY(.5)) == 0 )
         @  0,70 SAY " " + TIME() + " "

      END

   ENDIF

   IF ( nKey == K_DOWN )
      b:down()

   ELSEIF ( nKey == K_UP )
      b:up()

   ELSEIF ( nKey == K_PGDN )
      b:pageDown()

   ELSEIF ( nKey == K_PGUP )
      b:pageUp()
			
   ELSEIF ( nKey == K_CTRL_PGUP )
      b:goTop()

   ELSEIF ( nKey == K_CTRL_PGDN )
      b:goBottom()

   ELSEIF ( nKey == K_RIGHT )
      b:right()

   ELSEIF ( nKey == K_LEFT )
      b:left()

   ELSEIF ( nKey == K_HOME )
      b:home()

   ELSEIF ( nKey == K_END )
      b:end()

   ELSEIF ( nKey == K_CTRL_LEFT )
      b:panLeft()

   ELSEIF ( nKey == K_CTRL_RIGHT )
      b:panRight()

   ELSEIF ( nKey == K_CTRL_HOME )
      b:panHome()

   ELSEIF ( nKey == K_CTRL_END )
      b:panEnd()

   ELSEIF ( nKey == K_ESC )
      SETCURSOR(nCursSave)
      RETURN NIL

   ELSEIF ( nKey == K_RETURN )
      DoGet( b )

   ELSE
      KEYBOARD CHR(nKey)
      DoGet( b )

   ENDIF

END
RETURN NIL

STATIC FUNCTION DoGet( b )
LOCAL nCursSave
LOCAL column, get, nKey

nCursSave := SETCURSOR(SC_NORMAL)

// make sure browse is stable
WHILE ( !b:stabilize() ); END

// get column object from browse
column := b:getColumn( b:colPos )

// create a corresponding GET
get := GetNew(ROW(), COL(), column:block,;
              column:heading,, b:colorSpec)

// read it
READMODAL( {get} )

// force redisplay of current row
b:refreshCurrent()

// check exit key
nKey := LASTKEY()
IF ( nKey == K_UP .OR. nKey == K_DOWN .OR. ;
     nKey == K_PGUP .OR. nKey == K_PGDN )
     KEYBOARD CHR( nKey )

ENDIF
SETCURSOR(SC_NONE)
RETURN NIL

// EOF - TBR9.PRG //
